<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Integrator &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/sphinx_highlight.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Solving the incompressible Navier-Stokes Equation" href="system.html" />
    <link rel="prev" title="Cavity flow" href="PhysicalProblems/cavity_flow.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="grid.html">Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="physical_problem.html">Physical Problem</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Integrator</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#constructor">Constructor</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Integrator.__init__"><code class="docutils literal notranslate"><span class="pre">Integrator.__init__()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#methods">Methods</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Integrator.get_methods"><code class="docutils literal notranslate"><span class="pre">Integrator.get_methods()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#explicit-euler">Explicit Euler</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Integrator.explicit_Euler"><code class="docutils literal notranslate"><span class="pre">Integrator.explicit_Euler()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#runge-kutta-4">Runge Kutta 4</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Integrator.Runge_Kutta_4"><code class="docutils literal notranslate"><span class="pre">Integrator.Runge_Kutta_4()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#adaptive-step-size-method">Adaptive step size method</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Integrator.adaptive_step_size"><code class="docutils literal notranslate"><span class="pre">Integrator.adaptive_step_size()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Integrator</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/integrator.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="integrator">
<h1>Integrator<a class="headerlink" href="#integrator" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line"><code class="docutils literal notranslate"><span class="pre">Integrator</span></code> is used to step forward in time with a numerical
integration method.</div>
<div class="line">In the purpose of this package a numerical integration is done to update
the velocities for the next time step.</div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">Integrator</span></span></dt>
<dd><p>Used to do numerical integration.
In our purpose this is used to update the velocity in time
with different methods, such as the explicit Euler or Runge-Kutta 4.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">methods</span></span></dt>
<dd><p>A list with all different integration methods implemented
to step forward in time.
Take care: adaptive_step_size is also a method of this class.
However, it is no “integration” method, since it uses another
integration method and tries to get a better accuracy,</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>list</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<p>The constructor needs no arguments.</p>
<dl class="py method">
<dt class="sig sig-object py" id="src.Integrator.__init__">
<span class="sig-prename descclassname"><span class="pre">Integrator.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Integrator.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<p>Creates a list of possible integration methods.</p>
</dd></dl>

</section>
<section id="methods">
<h2>Methods<a class="headerlink" href="#methods" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">There are a few different methods implemented to step forward in time.</div>
<div class="line">Each has it’s own advantages and disadvantages.</div>
<div class="line">It is possible to get a list of all the different implemented integration methods with:</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Integrator.get_methods">
<span class="sig-prename descclassname"><span class="pre">Integrator.</span></span><span class="sig-name descname"><span class="pre">get_methods</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Integrator.get_methods" title="Permalink to this definition"></a></dt>
<dd><p>Get the implemented time integration methods</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>List of all implemented time integration methods</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>list</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="explicit-euler">
<h2>Explicit Euler<a class="headerlink" href="#explicit-euler" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The <code class="docutils literal notranslate"><span class="pre">explicit_Euler</span></code> is a simple method to step forward in time.</div>
<div class="line">It is an explicit method with a simple forward discretization.</div>
<div class="line">Therefore, the accuracy of this method is not the best.</div>
<div class="line">However, it is a very fast method</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Integrator.explicit_Euler">
<span class="sig-prename descclassname"><span class="pre">Integrator.</span></span><span class="sig-name descname"><span class="pre">explicit_Euler</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_n</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Integrator.explicit_Euler" title="Permalink to this definition"></a></dt>
<dd><p>Applies explicit Euler</p>
<p>This is an explicit integration method.
The following discretisation is applied:
df/dt ≈ (f(t+dt) - f(t)) / (dt) = rhs
↔ f(t+dt) = f(t) + dt * rhs</p>
<p>Note: No type checking is implemented since this method is only called
in the function “Chorin.update_time” where all necessary types
are checked.
Thus, it is highly recommended to check all necessary conditions
if this method is used out of this scope</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u_n</strong> (<em>np.ndarray</em>) – Value (velocity) at current time</p></li>
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step</p></li>
<li><p><strong>u_rhs</strong> (<em>np.ndarray</em>) – Rhs of the equation</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – If u_n or u_rhs is no numpy ndarray</p></li>
<li><p><strong>TypeError</strong> – If the time step size is no number</p></li>
<li><p><strong>ValueError</strong> – If the time step size in negative</p></li>
</ul>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Approximate value at new time (current time + time step)</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="runge-kutta-4">
<h2>Runge Kutta 4<a class="headerlink" href="#runge-kutta-4" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The fourth order Runge Kutta scheme is a more advanced method in comparison
to the explicit Euler.</div>
<div class="line">This method computes four different slopes to advance in time</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Integrator.Runge_Kutta_4">
<span class="sig-prename descclassname"><span class="pre">Integrator.</span></span><span class="sig-name descname"><span class="pre">Runge_Kutta_4</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_n</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Integrator.Runge_Kutta_4" title="Permalink to this definition"></a></dt>
<dd><p>Applies Runge-Kutta 4 Method</p>
<p>This is an explicit integration method of fourth order.</p>
<blockquote>
<div><ul class="simple">
<li><p>k1: slope at the beginning of the interval, using y</p></li>
<li><p>k2: slope at midpoint of the interval, using y and k1</p></li>
<li><p>k3: slope at midpoint of the interval, using y and k2</p></li>
<li><p>k4: slpope at end of interval, using y and k3</p></li>
</ul>
</div></blockquote>
<p>The approximated new value is:</p>
<blockquote>
<div><ul class="simple">
<li><p>u_{n+1} = u_n + dt/6 * (k1 + 2*k2 + 2*k3 + k4)</p></li>
</ul>
</div></blockquote>
<p>Find further explanation at:
&lt;<a class="reference external" href="https://en.wikipedia.org/wiki/Runge%E2%80%93Kutta_methods">https://en.wikipedia.org/wiki/Runge%E2%80%93Kutta_methods</a>&gt;</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u_n</strong> (<em>np.ndarray</em>) – Value (velocity) at current time</p></li>
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step</p></li>
<li><p><strong>u_rhs</strong> (<em>np.ndarray</em>) – Right-hand-side of the equation</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – If u_n or u_rhs is no numpy ndarray</p></li>
<li><p><strong>TypeError</strong> – If the time step size is no number</p></li>
<li><p><strong>ValueError</strong> – If the time step size in negative</p></li>
</ul>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Approximate value at new time (current time + time step)</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="adaptive-step-size-method">
<h2>Adaptive step size method<a class="headerlink" href="#adaptive-step-size-method" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Additionally, it is possible to reach higher accuracy with an
adaptive step size method.</div>
</div>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>The time step can get arbitrary small which can lead to
much longer compute time needed for the calculations.</p>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Integrator.adaptive_step_size">
<span class="sig-prename descclassname"><span class="pre">Integrator.</span></span><span class="sig-name descname"><span class="pre">adaptive_step_size</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_n</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v_n</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">dt</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">u_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v_rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">tolerance</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">method</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">callable</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Integrator.adaptive_step_size" title="Permalink to this definition"></a></dt>
<dd><p>Method to update in time with a adaptive step size.</p>
<p>Tries to get higher accuracy in the time update.
Therefore the solution in the next time step is calculated.
Then the time step is halved and the solution according
to this time step is calculated.
This is repeated till the difference in both solutions
is smaller then a given tolerance</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u_n</strong> (<em>np.ndarray</em>) – Velocity in x-direction at current time</p></li>
<li><p><strong>v_n</strong> (<em>np.ndarray</em>) – Velocity in y-direction at current time</p></li>
<li><p><strong>dt</strong> (<em>float</em>) – Length of time step</p></li>
<li><p><strong>u_rhs</strong> (<em>np.ndarray</em>) – Right-hand-side of the equation for the velocity in x-direction</p></li>
<li><p><strong>v_rhs</strong> (<em>np.ndarray</em>) – Right-hand-side of the equation for the velocity in y-direction</p></li>
<li><p><strong>tolerance</strong> (<em>float</em>) – A Prescribed tolerance of how accurate the scheme should be</p></li>
<li><p><strong>method</strong> (<em>callable</em>) – The time update method which is used</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – If u_n, v_n, u_rhs or v_rhs is no numpy ndarray</p></li>
<li><p><strong>TypeError</strong> – If the time step size or the tolerance is no number</p></li>
<li><p><strong>ValueError</strong> – If the time step size or the tolerance is negative</p></li>
<li><p><strong>TypeError</strong> – If the integration method is no function</p></li>
</ul>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Approximate value at new time and the used time step length
to compute this value</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray, float</p>
</dd>
</dl>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="PhysicalProblems/cavity_flow.html" class="btn btn-neutral float-left" title="Cavity flow" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="system.html" class="btn btn-neutral float-right" title="Solving the incompressible Navier-Stokes Equation" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>